from typing import TypedDict
from datacaster.classes import CastDataClass


class GroupData(CastDataClass):
    name: str
    object_id: str
    __class_config__ = {"rename_fields": {"display_name": "name"}}


class Group(TypedDict):
    """
    - Contains information about an Azure AD Group

    !!! info "AD Group Keys"

        __name__:  Group name

        __object_id__: Group ID

    """


class UserData(CastDataClass):
    name: str
    principal_name: str
    object_id: str
    __class_config__ = {"rename_fields": {"display_name": "name", "user_principal_name": "principal_name"}}


class User(TypedDict):
    """
    - Contains information about an Azure AD User

    !!! info "AD User Keys"

        __name__:  User display name

        __principal_name__: User principal name

        __object_id__: User ID

    """


__annotations__ = UserData.__dict__["__annotations__"]
